image: docker:latest
services:
  - docker:dind

variables:
  HEROKU_REGISTRY_IMAGE: registry.heroku.com/${HEROKU_APP_NAME}/web

stages:
  - push
  - deploy

build_image:
  stage: push
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u florian.martin63000@gmail.com -p ${HEROKU_TOKEN} registry.heroku.com
  script:
    - docker build --build-arg CONFIG_USERNAME_ARG=${CONFIG_USERNAME} --build-arg CONFIG_PASSWORD_ARG=${CONFIG_PASSWORD} --build-arg CONFIG_SERVER_URL_ARG=${CONFIG_SERVER_URL} --build-arg JWT_SECRET_ARG=${JWT_SECRET} -t ${HEROKU_REGISTRY_IMAGE} .
    - docker push ${HEROKU_REGISTRY_IMAGE}

deploy_to_heroku:
  only:
    - master
  when: manual
  stage: deploy
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker run --rm -e HEROKU_API_KEY=${HEROKU_API_KEY} wingrunr21/alpine-heroku-cli container:release web --app ${HEROKU_APP_NAME}

# # This solution also works:
# deploy_to_heroku:
#   stage: deploy
#   image: node:10.17-alpine
#   before_script:
#     - apk add curl bash
#     - curl https://cli-assets.heroku.com/install.sh | sh
#   script:
#     - heroku container:release -a ${HEROKU_APP_NAME} web
